### A free/open-source library for quantitative finance

Public Member Functions | Protected Member Functions | Protected Attributes
CPICapFloorTermPriceSurface Class Reference

Provides cpi cap/floor prices by interpolation and put/call parity (not cap/floor/swap* parity). More...

`#include <ql/experimental/inflation/cpicapfloortermpricesurface.hpp>`

Inheritance diagram for CPICapFloorTermPriceSurface:
[legend]

List of all members.

## Public Member Functions

CPICapFloorTermPriceSurface (Real nominal, Real baseRate, const Period &observationLag, const Calendar &cal, const BusinessDayConvention &bdc, const DayCounter &dc, const Handle< ZeroInflationIndex > &zii, const Handle< YieldTermStructure > &yts, const std::vector< Rate > &cStrikes, const std::vector< Rate > &fStrikes, const std::vector< Period > &cfMaturities, const Matrix &cPrice, const Matrix &fPrice)

Handle< ZeroInflationIndex > | zeroInflationIndex () const
| is based on
virtual std::vector< Rate > | strikes () const
virtual std::vector< Rate > | capStrikes () const
virtual std::vector< Rate > | floorStrikes () const
virtual std::vector< Period > | maturities () const
virtual const Matrix & | capPrices () const
virtual const Matrix & | floorPrices () const
virtual Rate | minStrike () const
virtual Rate | maxStrike () const
virtual Date | minDate () const
virtual Date | maxDate () const
| the latest date for which the curve can return values
virtual Date | cpiOptionDateFromTenor (const Period &p) const
InflationTermStructure interface
Period | observationLag () const
Date | baseDate () const
| minimum (base) date
virtual Real | nominal () const
| inspectors
virtual BusinessDayConvention | businessDayConvention () const
virtual Real | price (const Period &d, Rate k) const
virtual Real | capPrice (const Period &d, Rate k) const
virtual Real | floorPrice (const Period &d, Rate k) const
virtual Real | price (const Date &d, Rate k) const =0
virtual Real | capPrice (const Date &d, Rate k) const =0
virtual Real | floorPrice (const Date &d, Rate k) const =0

## Protected Member Functions

virtual bool | checkStrike (Rate K)
virtual bool | checkMaturity (const Date &d)

## Protected Attributes

Handle< ZeroInflationIndex > | zii_
std::vector< Rate > | cStrikes_
std::vector< Rate > | fStrikes_
std::vector< Period > | cfMaturities_
std::vector< Real > | cfMaturityTimes_
Matrix | cPrice_
Matrix | fPrice_
std::vector< Rate > | cfStrikes_

## Detailed Description

Provides cpi cap/floor prices by interpolation and put/call parity (not cap/floor/swap* parity).

The inflation index MUST contain a ZeroInflationTermStructure as this is used to create ATM. Unlike YoY price surfaces we assume that 1) an ATM ZeroInflationTermStructure is available and 2) that it is safe to use it. This is supported by the fact that no stripping is required for CPI cap/floors as they only give one flow.

cpi cap/floors have a single (one) flow (unlike nominal caps) because they observe cumulative inflation up to their maturity. Options are on CPI(T)/CPI(0) but strikes are quoted for yearly average inflation, so require transformation via (1+quote)^T to obtain actual strikes. These are consistent with ZCIIS quoting conventions.

The observationLag is that for the referenced instrument prices. Strikes are as-quoted not as-used.

## Member Function Documentation

Period observationLag | ( |  | ) | const`[virtual]`

The TS observes with a lag that is usually different from the availability lag of the index. An inflation rate is given, by default, for the maturity requested assuming this lag.

Reimplemented from InflationTermStructure.

Date baseDate | ( |  | ) | const`[virtual]`

minimum (base) date

Important in inflation since it starts before nominal reference date. Changes depending whether index is interpolated or not. When interpolated the base date is just observation lag before nominal. When not interpolated it is the beginning of the relevant period (hence it is easy to create interpolated fixings from a not-interpolated curve because interpolation, usually, of fixings is forward looking).

Implements InflationTermStructure.

Real nominal | ( |  | ) | const`[virtual]`

inspectors

Note:
  you don't know if price() is a cap or a floor without checking the ZeroInflation ATM level.

virtual Real price | ( | const Period & | d,
|  | Rate | k
| ) |  | const`[virtual]`

Warning:
  you MUST remind the compiler in any descendants with the using:: mechanism because you overload the names remember that the strikes use the quoting convention